diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 661b1477e..6159348c8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -247,6 +247,7 @@ public class BlockModelDispatcher
 
         addDispatch(new BlockModelStandard<>(Blocks.SAND).setAllTextures(BLOCK_TEXTURES, "minecraft:block/sand"));
         addDispatch(new BlockModelStandard<>(Blocks.GRAVEL).setAllTextures(BLOCK_TEXTURES, "minecraft:block/gravel"));
+        addDispatch(new BlockModelStandard<>(Blocks.SULFUR).setAllTextures(BLOCK_TEXTURES, "minecraft:block/sulfur"));
 
         addDispatch(new BlockModelStandard<>(Blocks.BEDROCK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/bedrock"));
         addDispatch(new BlockModelFullyRotatable<>(Blocks.BONESHALE)
@@ -396,6 +397,10 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/diamond/granite"));
         addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_PERMAFROST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/diamond/permafrost"));
 
+        addDispatch(new BlockModelStandard<>(Blocks.CRYSTAL).setAllTextures(BLOCK_TEXTURES,"minecraft:block/nether_crystal/crystal"));
+        addDispatch(new BlockModelCrossedSquares<>(Blocks.CRYSTAL_STALK).setAllTextures(BLOCK_TEXTURES,"minecraft:block/nether_crystal/stalk"));
+        addDispatch(new BlockModelCrystallineNetherrack<>(Blocks.NETHERRACK_CRYSTALLINE).setAllTextures(BLOCK_TEXTURES,"minecraft:block/nether_crystal/crystal_netherrack"));
+
         addDispatch(new BlockModelStandard<>(Blocks.ORE_NETHERCOAL_NETHERRACK)
             .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/nethercoal/netherrack")
             .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/ore/nethercoal/netherrack_overlay"));
@@ -579,6 +584,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelBrazier<>(Blocks.BRAZIER_ACTIVE)
             .setTex(BLOCK_TEXTURES, "minecraft:block/brazier/base", S_TB)
             .setTex(BLOCK_TEXTURES, "minecraft:block/brazier/side", S_SIDES));
+        addDispatch(new BlockModelFire<>(Blocks.FIRE_COLD).setAllTextures(BLOCK_TEXTURES, "minecraft:block/fire_cold"));
 
         addDispatch(new BlockModelStandard<>(Blocks.MOBSPAWNER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/mobspawner"));
         addDispatch(new BlockModelTransparent<>(Blocks.MOBSPAWNER_DEACTIVATED, true).setAllTextures(BLOCK_TEXTURES, "minecraft:block/mobspawner"));
@@ -642,11 +648,13 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelLayer<>(Blocks.LAYER_SLATE)
             .setTex(BLOCK_TEXTURES, "minecraft:block/slate_top", S_TB)
             .setTex(BLOCK_TEXTURES, "minecraft:block/slate_side", S_SIDES));
+        addDispatch(new BlockModelLayer<>(Blocks.LAYER_ASH).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_ash"));
 
         addDispatch(new BlockModelIce<>(Blocks.ICE).onRenderLayer(1).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ice"));
         addDispatch(new BlockModelStandard<>(Blocks.PERMAICE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/permaice"));
 
         addDispatch(new BlockModelStandard<>(Blocks.BLOCK_SNOW).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_snow"));
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_ASH).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_ash"));
 
         addDispatch(new BlockModelCactus<>(Blocks.CACTUS).withCustomItemBounds(0, 0, 0, 1, 1, 1)
             .setTex(BLOCK_TEXTURES, "minecraft:block/cactus/top", Side.TOP)
@@ -694,11 +702,11 @@ public class BlockModelDispatcher
             .setTex(OVERBRIGHT_TEXTURES, "minecraft:block/pumpkin_redstone/front_overlay", Side.NORTH));
 
 
-        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_netherrack"));
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_netherrack/normal"));
         addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK_IGNEOUS)
-            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_netherrack_igneous")
-            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/cobbled_netherrack_igneous_overlay"));
-        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK_MOSSY).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_netherrack_mossy"));
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_netherrack/igneous")
+            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/cobbled_netherrack/igneous_overlay"));
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK_MOSSY).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_netherrack/mossy"));
         addDispatch(new BlockModelStandard<>(Blocks.NETHERRACK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/netherrack"));
         addDispatch(new BlockModelStandard<>(Blocks.BRICK_NETHERRACK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_netherrack"));
         addDispatch(new BlockModelSlab<>(Blocks.SLAB_NETHERRACK_POLISHED));
@@ -735,6 +743,11 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelLantern<>(Blocks.LANTERN_FIREFLY_RED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/lantern_firefly/red"));
         addDispatch(new BlockModelJar<>(Blocks.JAR_GLASS));
 
+        addDispatch(new BlockModelJarButterfly<>(Blocks.JAR_BUTTERFLY_BLUE).withTextures("minecraft:block/jar_butterfly"));
+        addDispatch(new BlockModelJarButterfly<>(Blocks.JAR_BUTTERFLY_ORANGE).withTextures("minecraft:block/jar_butterfly"));
+        addDispatch(new BlockModelJarButterfly<>(Blocks.JAR_BUTTERFLY_PINK).withTextures("minecraft:block/jar_butterfly"));
+        addDispatch(new BlockModelJarButterfly<>(Blocks.JAR_BUTTERFLY_SILVER).withTextures("minecraft:block/jar_butterfly"));
+
         addDispatch(new BlockModelPebbles<>(Blocks.OVERLAY_PEBBLES));
 
         addDispatch(new BlockModelFenceThin<>(Blocks.FENCE_CHAINLINK,TextureRegistry.getTexture("minecraft:block/fence_chain/center"), null, TextureRegistry.getTexture("minecraft:block/fence_chain/top"), TextureRegistry.getTexture("minecraft:block/fence_chain/column")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/fence_chain/center"));
@@ -746,5 +759,9 @@ public class BlockModelDispatcher
             .setTex(BLOCK_TEXTURES, "minecraft:block/basket/side", S_SIDES));
 
         addDispatch(new BlockModelStandard<>(Blocks.PAPER_WALL).setAllTextures(BLOCK_TEXTURES, "minecraft:block/paperwall"));
+
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_STONE_LOWER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/stone"));
+        addDispatch(new BlockModelEmpty<>(Blocks.STATUE_STONE_UPPER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/stone"));
     }
 }
+
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJarButterfly.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJarButterfly.java
new file mode 100644
index 000000000..16ff1dd3c
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJarButterfly.java
@@ -0,0 +1,180 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicJarButterfly;
+import net.minecraft.core.util.helper.Side;
+
+public class BlockModelJarButterfly<T extends BlockLogic> extends BlockModelStandard<T>{
+
+    public BlockModelJarButterfly(Block<T> block) {
+        super(block);
+    }
+
+    @Override
+    public boolean render(Tessellator tessellator, int x, int y, int z) {
+        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+        boolean isHanging = (meta & BlockLogicJarButterfly.MASK_HANGING) == 0;
+        boolean isAngled = (meta & BlockLogicJarButterfly.MASK_ANGLED) != 0;
+
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+            tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        }else {
+            brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        }
+        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+
+        float yOffset = isHanging ? 0f : 0.375f;
+
+        float intMinX = x + 0.5f - (2f / 16f);
+        float intMinY = y + yOffset + (1f / 16f);
+        float intMinZ = z + 0.5f - (2f / 16f);
+        float intMaxX = x + 0.5f + (2f / 16f);
+        float intMaxY = y + (0.4375f + yOffset);
+        float intMaxZ = z + 0.5f + (2f / 16f);
+
+        float extMinX = x + 0.5f - (3f / 16f);
+        float extMinY = y + yOffset;
+        float extMinZ = z + 0.5f - (3f / 16f);
+        float extMaxX = x + 0.5f + (3f / 16f);
+        float extMaxY = y + (0.5f + yOffset);
+        float extMaxZ = z + 0.5f + (3f / 16f);
+
+        float hookMinX = x + 0.5f - (2f / 16f);
+        float hookMinZ = z + 0.5f - (2f / 16f);
+        float hookMaxX = x + 0.5f + (2f / 16f);
+        float hookMaxY = intMaxY + (4f / 16f);
+        float hookMaxZ = z + 0.5f + (2f / 16f);
+
+//        if (isAngled)
+//        {
+//            float angle = (float)(java.lang.Math.PI / 4);
+//            float centerX = x + 0.5f;
+//            float centerY = y;
+//            float centerZ = z + 0.5f;
+//
+//            float oldExtMaxY = extMaxY;
+//            float[] r = rotateAroundPoint(intMinX - centerX, intMinY - centerY, intMinZ - centerZ, 0, 0, angle);
+//            intMinX = r[0] + centerX;
+//            intMinY = r[1] + centerY;
+//            intMinZ = r[2] + centerZ;
+//
+//            r = rotateAroundPoint(intMaxX - centerX, intMaxY - centerY, intMaxZ - centerZ, 0, 0, angle);
+//            intMaxX = r[0] + centerX;
+//            intMaxY = r[1] + centerY;
+//            intMaxZ = r[2] + centerZ;
+//
+//            r = rotateAroundPoint(extMinX - centerX, extMinY - centerY, extMaxZ - centerZ, 0, 0, angle);
+//            extMinX = r[0] + centerX;
+//            extMinY = r[1] + centerY;
+//            extMinZ = r[2] + centerZ;
+//
+//            r = rotateAroundPoint(extMaxX - centerX, extMaxY - centerY, extMaxZ - centerZ, 0, 0, angle);
+//            extMaxX = r[0] + centerX;
+//            extMaxY = r[1] + centerY;
+//            extMaxZ = r[2] + centerZ;
+//
+//            r = rotateAroundPoint(hookMinX - centerX, oldExtMaxY - centerY, hookMinZ - centerZ, 0, 0, angle);
+//            hookMinX = r[0] + centerX;
+//            hookMinZ = r[2] + centerZ;
+//
+//            r = rotateAroundPoint(hookMaxX - centerX, hookMaxY - centerY, hookMaxZ - centerZ, 0, 0, angle);
+//            hookMaxX = r[0] + centerX;
+//            hookMaxY = r[1] + centerY;
+//            hookMaxZ = r[2] + centerZ;
+//        }
+
+        IconCoordinate texIndex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, meta);
+
+        double texU = texIndex.getIconUMin();
+        double texV = texIndex.getIconVMin();
+
+        double onePix = 1f/16;
+
+        //exterior shell uvs
+        double extSideMinU = texU;
+        double extSideMaxU = texIndex.getSubIconU(onePix * 6);
+        double extSideMinV = texIndex.getSubIconV(onePix * 6);
+        double extSideMaxV = texIndex.getSubIconV(onePix * 14);
+
+        double extTopMinU = texU;
+        double extTopMaxU = texIndex.getSubIconU(onePix * 6);
+        double extTopMinV = texV;
+        double extTopMaxV = texIndex.getSubIconV(onePix * 6);
+
+        double extBottomMinU = texIndex.getSubIconU(onePix * 6);
+        double extBottomMaxU = texIndex.getSubIconU(onePix * 12);
+        double extBottomMinV = texV;
+        double extBottomMaxV = texIndex.getSubIconV(onePix * 6);
+
+        //hook uvs
+        double hookMinU = texIndex.getSubIconU(onePix * 10);
+        double hookMaxU = texIndex.getSubIconU(onePix * 16);
+        double hookMinV = texIndex.getSubIconV(onePix * 6);
+        double hookMaxV = texIndex.getSubIconV(onePix * 10);
+
+        // Render sides ext
+        tessellator.addVertexWithUV(extMaxX, extMinY, extMinZ, extSideMinU, extSideMaxV);
+        tessellator.addVertexWithUV(extMinX, extMinY, extMinZ, extSideMaxU, extSideMaxV);
+        tessellator.addVertexWithUV(extMinX, extMaxY, extMinZ, extSideMaxU, extSideMinV);
+        tessellator.addVertexWithUV(extMaxX, extMaxY, extMinZ, extSideMinU, extSideMinV);
+
+        tessellator.addVertexWithUV(extMinX, extMinY, extMaxZ, extSideMinU, extSideMaxV);
+        tessellator.addVertexWithUV(extMaxX, extMinY, extMaxZ, extSideMaxU, extSideMaxV);
+        tessellator.addVertexWithUV(extMaxX, extMaxY, extMaxZ, extSideMaxU, extSideMinV);
+        tessellator.addVertexWithUV(extMinX, extMaxY, extMaxZ, extSideMinU, extSideMinV);
+
+        tessellator.addVertexWithUV(extMaxX, extMinY, extMaxZ, extSideMinU, extSideMaxV);
+        tessellator.addVertexWithUV(extMaxX, extMinY, extMinZ, extSideMaxU, extSideMaxV);
+        tessellator.addVertexWithUV(extMaxX, extMaxY, extMinZ, extSideMaxU, extSideMinV);
+        tessellator.addVertexWithUV(extMaxX, extMaxY, extMaxZ, extSideMinU, extSideMinV);
+
+        tessellator.addVertexWithUV(extMinX, extMinY, extMinZ, extSideMinU, extSideMaxV);
+        tessellator.addVertexWithUV(extMinX, extMinY, extMaxZ, extSideMaxU, extSideMaxV);
+        tessellator.addVertexWithUV(extMinX, extMaxY, extMaxZ, extSideMaxU, extSideMinV);
+        tessellator.addVertexWithUV(extMinX, extMaxY, extMinZ, extSideMinU, extSideMinV);
+
+        // Render top ext
+        tessellator.addVertexWithUV(extMinX, extMaxY, extMaxZ, extTopMinU, extTopMaxV);
+        tessellator.addVertexWithUV(extMaxX, extMaxY, extMaxZ, extTopMaxU, extTopMaxV);
+        tessellator.addVertexWithUV(extMaxX, extMaxY, extMinZ, extTopMaxU, extTopMinV);
+        tessellator.addVertexWithUV(extMinX, extMaxY, extMinZ, extTopMinU, extTopMinV);
+
+        // Render bottom ext
+        tessellator.addVertexWithUV(extMinX, extMinY, extMinZ, extBottomMinU, extBottomMinV);
+        tessellator.addVertexWithUV(extMaxX, extMinY, extMinZ, extBottomMaxU, extBottomMinV);
+        tessellator.addVertexWithUV(extMaxX, extMinY, extMaxZ, extBottomMaxU, extBottomMaxV);
+        tessellator.addVertexWithUV(extMinX, extMinY, extMaxZ, extBottomMinU, extBottomMaxV);
+
+        // Render hook
+        tessellator.addVertexWithUV(hookMinX, intMaxY, hookMinZ, hookMinU, hookMaxV);
+        tessellator.addVertexWithUV(hookMaxX, intMaxY, hookMaxZ, hookMaxU, hookMaxV);
+        tessellator.addVertexWithUV(hookMaxX, hookMaxY, hookMaxZ, hookMaxU, hookMinV);
+        tessellator.addVertexWithUV(hookMinX, hookMaxY, hookMinZ, hookMinU, hookMinV);
+
+        tessellator.addVertexWithUV(hookMinX, hookMaxY, hookMinZ, hookMaxU, hookMinV);
+        tessellator.addVertexWithUV(hookMaxX, hookMaxY, hookMaxZ, hookMinU, hookMinV);
+        tessellator.addVertexWithUV(hookMaxX, intMaxY, hookMaxZ, hookMinU, hookMaxV);
+        tessellator.addVertexWithUV(hookMinX, intMaxY, hookMinZ, hookMaxU, hookMaxV);
+
+        tessellator.addVertexWithUV(hookMinX, intMaxY, intMaxZ, hookMinU, hookMaxV);
+        tessellator.addVertexWithUV(hookMaxX, intMaxY, intMinZ, hookMaxU, hookMaxV);
+        tessellator.addVertexWithUV(hookMaxX, hookMaxY, intMinZ, hookMaxU, hookMinV);
+        tessellator.addVertexWithUV(hookMinX, hookMaxY, intMaxZ, hookMinU, hookMinV);
+
+        tessellator.addVertexWithUV(hookMinX, hookMaxY, hookMaxZ, hookMaxU, hookMinV);
+        tessellator.addVertexWithUV(hookMaxX, hookMaxY, hookMinZ, hookMinU, hookMinV);
+        tessellator.addVertexWithUV(hookMaxX, intMaxY, hookMinZ, hookMinU, hookMaxV);
+        tessellator.addVertexWithUV(hookMinX, intMaxY, hookMaxZ, hookMaxU, hookMaxV);
+
+        return true;
+    }
+    @Override
+    public boolean shouldItemRender3d() {
+        return false;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererJarButterfly.java b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererJarButterfly.java
new file mode 100644
index 000000000..3d54a0304
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererJarButterfly.java
@@ -0,0 +1,13 @@
+package net.minecraft.client.render.blockentity;
+
+import net.minecraft.client.render.entity.MobRendererButterfly;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.entity.TileEntityJarButterfly;
+import net.minecraft.core.util.helper.MathHelper;
+
+public class TileEntityRendererJarButterfly extends TileEntityRenderer<TileEntityJarButterfly>{
+    @Override
+    public void doRender(Tessellator tessellator, TileEntityJarButterfly tileEntity, double x, double y, double z, float partialTick) {
+        MobRendererButterfly.drawButterfly(tessellator, tileEntity.ticksRan, 0.70f, 0, x + 0.5, y - 0.125 + MathHelper.sin((tileEntity.ticksRan + partialTick)/20) * (0.0625), z + 0.5, partialTick, renderDispatcher.textureManager, "/assets/minecraft/textures/entity/butterfly/" + tileEntity.color.name + "/0_0.png");
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java
index 519558e45..d9278d4a5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererSign.java
@@ -3,7 +3,10 @@ package net.minecraft.client.render.blockentity;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.model.ModelBase;
 import net.minecraft.client.render.model.ModelSign;
+import net.minecraft.client.render.model.ModelSkeleton;
+import net.minecraft.client.render.model.ModelZombie;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -18,8 +21,10 @@ import org.lwjgl.opengl.GL11;
 public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 {
 
-	private final Minecraft mc = Minecraft.getMinecraft();
-	
+    private final Minecraft mc = Minecraft.getMinecraft();
+    private final ModelSign modelSign;
+
+
     public TileEntityRendererSign()
     {
         modelSign = new ModelSign();
@@ -79,7 +84,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         EnumSignPicture picture = tileEntity.getPicture();
         drawTexturedModalRect(-48, -24, 48, 24, TextureRegistry.getTexture(picture.getTextureKey()));
         GL11.glPopMatrix();
-        
+
         // Render text
         float lightLevel = mc.currentWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
         float lightOffset = 0f;
@@ -91,7 +96,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
                 LightmapHelper.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
             }
         }
-        
+
         GL11.glPushMatrix();
         f4 = 0.01666667F * scale;
         GL11.glTranslatef(0.0F, 0.5F * scale, 0.065F * scale);
@@ -138,6 +143,4 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         tessellator.draw();
     }
 
-
-    private final ModelSign modelSign;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererStatue.java b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererStatue.java
new file mode 100644
index 000000000..be550f04f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererStatue.java
@@ -0,0 +1,121 @@
+package net.minecraft.client.render.blockentity;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.model.ModelBiped;
+import net.minecraft.client.render.model.ModelPlayer;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.entity.TileEntityStatue;
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.item.*;
+import org.lwjgl.opengl.GL11;
+
+public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatue> {
+
+    private final Minecraft mc = Minecraft.getMinecraft();
+    private final ModelPlayer model;
+    private final ModelBiped modelArmorA;
+    private final ModelBiped modelArmorB;
+
+
+    public TileEntityRendererStatue() {
+        this.model = new ModelPlayer(0.0f);
+        this.modelArmorA = new ModelBiped(1.0f);
+        this.modelArmorB = new ModelBiped(0.5f);
+    }
+
+    public void renderAt(TileEntityStatue tileEntity, double x, double y, double z) {
+        TileEntityStatue.Pose pose = tileEntity.getPose();
+
+        final float scale = 0.0625f;
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        loadTexture("/assets/minecraft/textures/entity/statue_stone.png");
+        GL11.glPushMatrix();
+        GL11.glTranslatef((float) x + 0.5f, (float) y + 1.5f, (float) z + 0.5f);
+        float rotation = (float)(tileEntity.getBlockMeta() * 360) / 16F;
+        GL11.glRotatef(-rotation, 0.0F, 1.0F, 0.0F);
+        GL11.glScalef(scale, -scale, -scale);
+        GL11.glDisable(GL11.GL_CULL_FACE);
+        renderModel(this.model, pose);
+        for (int i = 0; i < 4; i++) {
+            renderArmor(tileEntity, i, pose);
+        }
+        GL11.glEnable(GL11.GL_CULL_FACE);
+        GL11.glPopMatrix();
+    }
+
+    private void applyPose(TileEntityStatue.Pose pose, ModelBiped model) {
+        model.armLeft.xRot = pose.leftArmPitch;
+        model.armRight.xRot = pose.rightArmPitch;
+        model.legLeft.xRot = pose.leftLegPitch;
+        model.legRight.xRot = pose.rightLegPitch;
+        model.head.xRot = pose.headPitch;
+        model.head.yRot = pose.headYaw;
+    }
+
+    private void renderModel(ModelBiped model, TileEntityStatue.Pose pose) {
+        final float scale = 1.0f;
+
+        model.setupAnimation(0.0f, 0.0f, 0.0f, 0.0f, 0.0f, scale);
+        applyPose(pose, model);
+
+        model.head.render(scale);
+        model.body.render(scale);
+        model.armRight.render(scale);
+        model.armLeft.render(scale);
+        model.legRight.render(scale);
+        model.legLeft.render(scale);
+        model.hair.render(scale);
+    }
+
+    @Override
+    public void doRender(Tessellator tessellator, TileEntityStatue tileEntity, double x, double y, double z,
+                         float partialTick) {
+        renderAt(tileEntity, x, y, z);
+    }
+
+    private boolean renderArmor(TileEntityStatue entity, int layer, TileEntityStatue.Pose pose) {
+        ItemStack itemstack = entity.getItemInArmorSlot(HumanArmorShape.values()[(entity.getNumArmorSlots() - 1) - layer]);
+        if (itemstack != null) {
+            Item item = itemstack.getItem();
+            ModelBiped toDraw = null;
+            if (item instanceof ItemQuiver) {
+                loadTexture("/assets/minecraft/textures/armor/quiver.png");
+                ModelBiped modelBiped = modelArmorA;
+                modelBiped.body.visible = layer == 1 || layer == 2;
+                toDraw = modelBiped;
+            }
+            if (item instanceof ItemQuiverEndless) {
+                loadTexture("/assets/minecraft/textures/armor/quiver_golden.png");
+                ModelBiped modelBiped = modelArmorA;
+                modelBiped.body.visible = layer == 1 || layer == 2;
+                toDraw = modelBiped;
+            }
+            if (item == Items.ARMOR_BOOTS_ICESKATES) {
+                loadTexture("/assets/minecraft/textures/armor/skates.png");
+                ModelBiped modelBiped = modelArmorA;
+                modelBiped.legRight.visible = layer == 2 || layer == 3;
+                modelBiped.legLeft.visible = layer == 2 || layer == 3;
+                toDraw = modelBiped;
+            }
+            if (item instanceof IArmorItem && ((IArmorItem) item).getArmorMaterial() != null) {
+                IArmorItem armorItem = (IArmorItem) item;
+                loadTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace, armorItem.getArmorMaterial().identifier.value, (layer != 2 ? 1 : 2)));
+                ModelBiped modelBiped = layer != 2 ? modelArmorA : modelArmorB;
+                modelBiped.head.visible = layer == 0;
+                modelBiped.hair.visible = layer == 0;
+                modelBiped.body.visible = layer == 1 || layer == 2;
+                modelBiped.armRight.visible = layer == 1;
+                modelBiped.armLeft.visible = layer == 1;
+                modelBiped.legRight.visible = layer == 2 || layer == 3;
+                modelBiped.legLeft.visible = layer == 2 || layer == 3;
+                toDraw = modelBiped;
+            }
+
+            if (toDraw != null) {
+                renderModel(toDraw, pose);
+                return true;
+            }
+        }
+        return false;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java b/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
index 47cd1d8a5..1d8363eeb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
+++ b/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
@@ -40,6 +40,7 @@ public class Colorizers {
 	public static Colorizer cacao;
 	public static Colorizer thorn;
 	public static Colorizer palm;
+	public static Colorizer crystal;
 
 	private static Dimension lastDimension;
 	private static Season lastSeason;
@@ -83,6 +84,7 @@ public class Colorizers {
 		cacao = add(new Colorizer("cacao"));
 		thorn = add(new Colorizer("thorn"));
 		palm = add(new Colorizer("palm"));
+		crystal = add(new Colorizer("crystal"));
 	}
 	
 	public static void update(boolean force) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java
index efc511ab2..9e5b5511a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFire.java
@@ -4,15 +4,18 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import org.jetbrains.annotations.NotNull;
 
 public class DynamicTextureFire extends DynamicTexture{
-	
 	protected float[] arr1;
 	protected float[] arr2;
 
 	private int height;
 	private float scaleFactor;
 
-	public DynamicTextureFire(@NotNull IconCoordinate targetTexture) {
+	private final boolean cold;
+
+	public DynamicTextureFire(@NotNull IconCoordinate targetTexture, boolean cold) {
 		super(targetTexture);
+
+		this.cold = cold;
 	}
 
 	@Override
@@ -64,15 +67,21 @@ public class DynamicTextureFire extends DynamicTexture{
 				l = 0.0F;
 			}
 
-			int r = (int)(l * 155.0F + 100.0F);
-			int g = (int)(l * l * 255.0F);
-			int b = (int)(l * l * l * l * l * l * l * l * l * l * 255.0F);
+			int r, g, b;
+			if (cold) {
+				r = (int)(l * 155.0F + 100.0F);
+				g = (int)(l * 155.0F + 100.0F);
+				b = (int)(l * 155.0F + 100.0F);
+			} else {
+				r = (int)(l * 155.0F + 100.0F);
+				g = (int)(l * l * 255.0F);
+				b = (int)(l * l * l * l * l * l * l * l * l * l * 255.0F);
+			}
 			short a = 255;
 			if(l < 0.5F) {
 				a = 0;
 			}
 
-
 			this.imageData[i * 4 + 0] = (byte)r;
 			this.imageData[i * 4 + 1] = (byte)g;
 			this.imageData[i * 4 + 2] = (byte)b;
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index fe24d1e57..15553c76d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -266,8 +266,7 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
         {
             bindTexture(entity.getDefaultEntityTexture());
         }
-        else
-        {
+        else {
             bindTexture(entity.getEntityTexture());
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
index 1bdee29f8..d2be306e3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.model.ModelBiped;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -10,22 +11,25 @@ import org.lwjgl.opengl.GL11;
 
 public class MobRendererBiped<T extends Mob> extends MobRenderer<T>
 {
-    public MobRendererBiped(ModelBiped model, float shadowSize)
+	protected ModelBiped modelBipedMain;
+
+
+	public MobRendererBiped(ModelBiped model, float shadowSize)
     {
         super(model, shadowSize);
-        modelBipedMain = model;
-    }
+
+        this.modelBipedMain = model;
+	}
 
 	@Override
 	protected void renderAdditional(T entity, float f) {
 		ItemStack itemstack = entity.getHeldItem();
 		if(itemstack != null) {
 			GL11.glPushMatrix();
-			modelBipedMain.armRight.translateTo(0.0625F);
+			this.modelBipedMain.armRight.translateTo(0.0625F);
+			BlockModel.setRenderBlocks(this.renderDispatcher.itemRenderer.renderBlocksInstance);
 			ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderItemThirdPerson(Tessellator.instance, renderDispatcher.itemRenderer, entity, itemstack, true);
 			GL11.glPopMatrix();
 		}
 	}
-
-    protected ModelBiped modelBipedMain;
 }
